package com.xyzc.start.domain.vo;

import lombok.Data;

import java.io.Serial;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * BaseUserMemberCardVo
 *
 * @author 杨兴卓
 */
@Data
public class BaseUserMemberCardVo implements Serializable {


    @Serial
    private static final long serialVersionUID = 1L;

    /**
     * 会员卡id
     */
    private Long id;

    /**
     * 会员方案id
     */
    private Long memberCardSchemeId;

    /**
     * 会员卡logo ossId
     */
    private Long ossUrl;

    /**
     * 会员卡名称
     */
    private String cardName;

    /**
     * 是否是基础会员卡 0-否 1-是
     */
    private Integer isBaseCard;


    /**
     * 会员卡别名
     */
    private String cardAliasName;

    /**
     * 会员卡售价
     */
    private BigDecimal price;

    /**
     * 描述
     */
    private String description;

    /**
     * 每天使用次数
     */
    private Integer everydayUseNumber;

    /**
     * 权益集合
     */
    private List<EquityVo> equityList;

    /**
     * 会员卡状态 0-正常 1-停用
     */
    private Integer status;

    /**
     * 到期时间
     */
    private Date expireTime;

}


