package com.xyzc.start.mapper;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.xyzc.common.mybatis.core.mapper.BaseMapperPlus;
import com.xyzc.start.domain.BaseUser;
import com.xyzc.start.domain.bo.HobbyBo;
import com.xyzc.start.domain.vo.BaseUserVo;
import com.xyzc.start.domain.vo.MemberCardVo;

import java.util.List;

public interface BaseUserMapper extends BaseMapperPlus<BaseUser, BaseUserVo> {


    default BaseUserVo queryDetailByMobile(String mobile) {
        return this.selectVoOne(new LambdaQueryWrapper<BaseUser>()
                .eq(BaseUser::getPhoneNumber, mobile)
        );
    }

    default BaseUser queryDetailByUsername(String username) {
        return this.selectOne(new LambdaQueryWrapper<BaseUser>()
                .eq(BaseUser::getUserName, username)
        );
    }

    /**
     * @param userId
     * @return
     */
    List<MemberCardVo> queryMemberCardByUserId(Long userId);

    /**
     * @param openId
     * @param agentId
     * @return
     */
    default BaseUser queryUserByOpenid(String openId, Long agentId) {
        return this.selectOne(new LambdaQueryWrapper<BaseUser>()
                .eq(BaseUser::getOpenid, openId)
                .eq(BaseUser::getAgentMerId, agentId)
        );
    }

    /**
     * 选择性获取用户信息，燃料，次数
     *
     * @param userId
     * @return
     */
    default BaseUserVo queryCurrentInfo(Long userId) {

        return this.selectVoOne(new LambdaQueryWrapper<BaseUser>()
                .select(BaseUser::getSurplusFuel)
                .eq(BaseUser::getId, userId)
        );
    }

    /**
     * @param userId
     * @param hobby
     */
    void saveHobbys(Long userId, HobbyBo hobby);
}
